import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * Write a description of class Hunter here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Hunter extends Auto
{
    private int direction = -1;   // default direction and image direction of car
    private int speed = 2 + Greenfoot.getRandomNumber(3);
    private static int DELAY = 90; 
    private static int STOPTIME = 20;
    private int stop = 0;
    int reload = 0;
    public Hunter (int dir) {
        if (dir == 1) {
            reverse();
        }
    }

    public void reverse()
    {
        getImage().mirrorHorizontally();
        direction = -direction;

    }

    /**
     * Act - do whatever the Hunter wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act() 
    {
        int x = getX();
        int y = getY();
        
        if (stop > 0) {
            stop--;
        }
        else {
            setLocation(x +  speed*direction, y);
        }

        if (x < 50 || x > getWorld().getWidth()-50) {    // out of World boundaries?
            getWorld().removeObject(this);
        }
        else if (reload > 0)     
        {
            reload --;     // count down to reload
        }
        else
        {
            fire();
            reload = DELAY+Greenfoot.getRandomNumber(30);
            stop = STOPTIME;
        }
    }  

    public void fire()
    {

        Bullet bullet = new Bullet();
        getWorld().addObject(bullet, getX(), getY());
        // Lucas see this code on how to rotate the bullet 
        // By default, the object travels horizontally from left to right.
        if (direction == -1) {     
            // hunter facing left, turn counter clockwise 135 degrees
            bullet.turn(-135);
        }
        else  
        {
            // hunter facing right, turn counter clockwise 40 degrees
            bullet.turn(-45);
        }

        bullet.getImage().scale(30,30);  // resize bullet
        bullet.move(70); // move bullet to fire from tip of gun.

    }
}
